REM
REM    Licensed Materials - Property of IBM
REM
REM    "Restricted Materials of IBM"
REM
REM    5724-U38, 5724-U39, 5724-U48
REM
REM     Copyright IBM Corp. 2016 All Rights Reserved
REM
REM     Copyright 2016 UNICOM Systems, Inc. - All Rights Reserved
REM
REM    US Government Users Restricted Rights - Use, duplication or
REM    disclosure restricted by GSA ADP Schedule Contract with
REM    IBM Corp.
REM

@ECHO off

:: This batch file runs the ODPPJavaSample program in the ODPP\Samples directory.
:: It is assummed that the batch file is being run from the ODPP\Samples\JavaAPI directory in a ModAPP installation.

SET CURRDIR=%~dp0
SET MODDIR=%CURRDIR%..\..\..


:: Set ODPP environment variables:
::    ODPPLIBL - The directory containing ODPP binaries 
::    ODPPLL   - The directory containing the ODPP license file
::    ODPPTRCL - The directory to which ODPP diagnostic traces will be written
SET ODPPLIBL=%MODDIR%\ODPP\Images64\win\bin\
SET ODPPLL=%MODDIR%\ODPP\Images64\win\bin\
SET ODPPTRCL=%MODDIR%\ODPP\Images64\win\trace\
if NOT EXIST %ODPPLIBL% (
 SET ODPPLIBL=%MODDIR%\ODPP\Images32\win\bin\
 SET ODPPLL=%MODDIR%\ODPP\Images32\win\bin\
 SET ODPPTRCL=%MODDIR%\ODPP\Images32\win\trace\
)


:: Add JRE and and ODPP bin directory to path.
:: If this is not being run from within a ModAPP installation, then please modify the
:: statements below to reflect the location of a JRE (32 bit or 64 bit, to match the ODPP bitness).
ECHO ;%PATH%; | find /C /I ";%MODDIR%\jdk\jre\bin;%ODPPLIBL%;" >NUL
IF "%ERRORLEVEL%" == "0" GOTO END
SET ERRORLEVEL=0
SET PATH=%PATH%;%MODDIR%\jdk\jre\bin;%ODPPLIBL%
:END

:: Execute the program 
%MODDIR%\jdk\jre\bin\java -classpath "%CURRDIR%\ODPPJavaSample.jar;%ODPPLIBL%\odppjava.jar" com.ibm.odppjavasample.ODPPJavaSample
pause
