#!/bin/sh
#
#   Licensed Materials - Property of IBM
#
#   "Restricted Materials of IBM"
#
#   5724-U38, 5724-U39, 5724-U48
#
#    Copyright IBM Corp. 2016 All Rights Reserved
#
#    Copyright 2016 UNICOM Systems, Inc. - All Rights Reserved
#
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#

# This script runs the ODPPJavaSample program in the ODPP/Samples directory.
# It is assummed that the script is being run from the ODPP/Samples/JavaAPI directory in a ModAPP installation.

CURRDIR=${PWD}
MODDIR=$CURRDIR/../../..

# Set ODPP environment variables:
#    ODPPLIBL - The directory containing ODPP binaries 
#    ODPPLL   - The directory containing the ODPP License file
#    ODPPTRCL - The directory to which ODPP diagnostic traces will be written
ODPPLIBL=$MODDIR/ODPP/Images64/rhel/bin/
ODPPLL=$MODDIR/ODPP/Images64/rhel/bin/
ODPPTRCL=$MODDIR/ODPP/Images64/rhel/trace/
if [ ! -d $ODPPLIBL ]; then
  ODPPLIBL=$MODDIR/ODPP/Images32/rhel/bin/
  ODPPLL=$MODDIR/ODPP/Images32/rhel/bin/
  ODPPTRCL=$MODDIR/ODPP/Images32/rhel/trace/
fi

# Add JRE and and ODPP bin directory to path.
# If this is not being run from within a ModAPP installation, then please modify the
# statements below to reflect the location of a JRE (32 bit or 64 bit, to match the ODPP bitness).
if [ ":$PATH:" != *":$MODDIR/jdk/jre/bin/:"* ]; then
PATH=$PATH:$MODDIR/jdk/jre/bin/
fi
if [ ":$LD_LIBRARY_PATH:" != *":ODPPLIBL:"* ]; then
LD_LIBRARY_PATH=$ODPPLIBL:$LD_LIBRARY_PATH
fi

export ODPPLIBL
export ODPPLL
export ODPPTRCL
export PATH
export LD_LIBRARY_PATH
export ODPPTRCCMD

# Execute the program 
$MODDIR/jdk/jre/bin/java -classpath "$CURRDIR/ODPPJavaSample.jar:$ODPPLIBL/ODPPJava.jar" com.ibm.odppjavasample.ODPPJavaSample
