REM 
REM -cr_beg-
REM ********************************************************************
REM IBM Confidential
REM OCO Source Materials
REM 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
REM (C) Copyright IBM Corp. 2013
REM The source code for this program is not published or otherwise
REM divested of its trade secrets, irrespective of what has
REM been deposited with the U.S. Copyright Office.
REM ********************************************************************
REM -cr_end-
REM 

REM Follow these steps to build the ODPP Hash Exit as a library/DLL for Windows 
REM 1. Set the VSROOT2K8 environment variable to the base of your Microsoft Visual Studio 2008 installation folder
REM 2. Create a base-type folder and copy:
REM    odpp_exit.h (header), odpp_hashexit.c (source code), ODPPHashExitWinExp.def (Module definition file), makewin.bat(Windows build script),
REM    ODPPHASHEXIT.sln (Solution) and ODPPHASHEXIT.vcproj (Project) into this base-type folder
REM 3. Run the build script makewin.bat
REM    It will generate ioqhashexit.dll into the Release-type sub-folder inside base-type folder where you have the source code.

if "%VSROOT2K8%" == "" goto MissingVSROOT

PUSHD .
SET ODPPPATHSAVE=%PATH%

SET mode=/rebuild
SET VSROOT=%VSROOT2K8%

:ODPPHASHEXIT
   Echo -------------------------------------------------------------------------------
   Echo -- %mode% Making ODPPHASHEXIT.VCPROJ Config:ODPPHASHEXIT - Win32 Release
   Echo -------------------------------------------------------------------------------
   SET PATH=%VSROOT%\COMMON7\IDE;%VSROOT%\VC\BIN;%VSROOT%\COMMON7\TOOLS\BIN;C:\WINDOWS;C:\WINDOWS\System32;C:\Program Files\Microsoft SDKs\Windows\v6.0A\bin;C:\WINDOWS\COMMAND;C:\WINDOWS\System32\WBEM
   SET INCLUDE=%VSROOT%\VC\INCLUDE;C:\Program Files\Microsoft SDKs\Windows\v6.0A\Include;%VSROOT%\SDK;%VSROOT%\VC\ATLMFC\INCLUDE;
   SET LIB=%VSROOT%\VC\LIB;C:\Program Files\Microsoft SDKs\Windows\v6.0A\Lib
   DEVENV.COM ODPPHASHEXIT.sln %mode% "Release" /project ODPPHASHEXIT.vcproj /useenv /out buildlog.txt
   IF ERRORLEVEL 1 GOTO STOPMAKE
   IF ERRORLEVEL 2 GOTO STOPMAKE     
   
   GOTO BuildDone
   
:MissingVSROOT
   @echo .
   @echo .  Be sure to specify the VSROOT2K8 environment variable 
   @echo .  with the root directory of VS .Net 2008
   @echo .
   goto ExitHere
   
:StopMake
   @ECHO Build terminated due to an error
   goto ExitHere

:BuildDone  
   @ECHO Build successful
   goto ExitHere

:ExitHere
   @SET PATH=%ODPPPATHSAVE%
   POPD