       CBL RENT,DLL,PGMN(LM),LIB,LIST,MAP
      *----------------------------------------------------------------
      *  THIS IS A SAMPLE EXIT FOR IBM'S OPTIM
      *  IT SHOWS AN EXAMPLE OF COBOL CALLING THE ODPP FUNCTION HASH
      *  THE EXIT IS STRUCTURED AS FOLLOWS:
      *  - UPON ENTRY, THE EXIT CHECKS TO SEE IF THIS IS A TERMINATION
      *     CALL (WHICH IS INDICATED BY A VALUE OF 0 IN THE DESTINATION
      *     COLUMN SUBSCRIPT).  IF SO, THE EXIT CLEANS UP AND RETURNS.
      *  - THE EXIT THEN CHECKS TO SEE IF THIS IS THE FIRST TIME IT HAS
      *     BEEN CALLED (INDICATED BY A VALUE OF 0 IN THE WORK AREA).
      *     IF SO, IT DETERMINES THE DESTINATION COLUMN, AND CHECKS THAT
      *      THE DATA TYPE IS COMPATIBLE WITH Hash output INFORMATION.
      *      It should be a form of numeric, INT, OR DECIMAL(9,0) DATA.
      *  - IF THE EXIT IS CALLED ON THE FIRST OR SUBSEQUENT DATA COLS,
      *     IT CALLS THE ODPP FUNCTION HSH.  IT MOVES THE VALUE BACK
      *     TO THE RETURN COLUMN.
      *  FOR INFORMATION ON THE SQLDA AND SQLVAR, CONSULT THE
      *     APPROPRIATE DB2 DOCUMENTATION FROM IBM.
      *  THIS PROGRAM MUST BE COMPILED WITH THE FOLLOWING OPTIONS:
      *     RENT,DLL,PGMN(LM),LIB
      *----------------------------------------------------------------
       ID DIVISION.
       PROGRAM-ID. "ODPPHASH".
       DATA DIVISION.
      *----------------------------------------------------------------
       WORKING-STORAGE SECTION.
      *----------------------------------------------------------------

      *
      * The following copybook contains ODPP structure definitions
      * and constants
      *
       COPY ODPPWAPI.

       01  EXIT-WORK.
          05  EW-SRC-SQLDA-PTR   POINTER.
          05  EW-DST-SQLDA-PTR   POINTER.
          05  EW-SVC-TOKEN       PIC S9(9) COMP-5.
          05  EW-DST-VAR-SUB     PIC S9(4) COMP-5 SYNC.
          05  EW-SRC-VAR-SUB     PIC S9(4) COMP-5 SYNC.

       01 COLUMN-NAME-INFO.
          05 COLUMN-NAME-INFO-ARRAY OCCURS 2 TIMES.
             10 COL-NAME-DBMS-TYPE PIC X.
             10 FILLER PIC X(3).
             10 COL-NAME-CODE-PAGE PIC S9(9) COMP-5.
             10 COL-NAME-PTR POINTER.

       01 SOURCE-COLUMN-NAME PIC X(30).
       01 DEST-COLUMN-NAME.
          05 DEST-COL-H      PIC X(1) VALUE "H".
          05 DEST-COL-D PIC X(29).
       01 HASH-COLUMN-NAME.
          05 HASH-COL-H      PIC X(1) VALUE "H".
          05 HASH-COL-D PIC X(29).
       77 NULL-PTR POINTER VALUE NULL.

      *
      * Provider name definition
      *
       77 PRV-NAME PIC X(5) VALUE Z"HASH".

       01 HASHCOL.
          05 HASHCOL-DBMS-TYPE PIC X VALUE 'N'.
          05 FILLER PIC X(3).
          05 HASHCOL-CODE-PAGE PIC S9(9) COMP-5 VALUE -1.
          05 HASHCOL-VAL-PTR POINTER.

       77 CM-ARG-PTR POINTER.
       77 ALLOC-INIT-BLOCK PIC 9 BINARY VALUE 1.
       77 SRC-IS-CHAR           PIC X.
       88 SRC-IS-CHAR-FALSE     VALUE LOW-VALUE.
       88 SRC-IS-CHAR-TRUE      VALUE X'01' THROUGH X'FF'.
       77 SRC-IS-VARCHAR        PIC X.
       88 SRC-IS-VARCHAR-FALSE  VALUE LOW-VALUE.
       88 SRC-IS-VARCHAR-TRUE   VALUE X'01' THROUGH X'FF'.
       77 SRC-IS-INTEGER        PIC X.
       88 SRC-IS-INTEGER-FALSE  VALUE LOW-VALUE.
       88 SRC-IS-INTEGER-TRUE   VALUE X'01' THROUGH X'FF'.
       77 SRC-IS-SMALLINT       PIC X.
       88 SRC-IS-SMALLINT-FALSE VALUE LOW-VALUE.
       88 SRC-IS-SMALLINT-TRUE  VALUE X'01' THROUGH X'FF'.
       77 DST-IS-CHAR           PIC X.
       88 DST-IS-CHAR-FALSE     VALUE LOW-VALUE.
       88 DST-IS-CHAR-TRUE      VALUE X'01' THROUGH X'FF'.
       77 DST-IS-VARCHAR        PIC X.
       88 DST-IS-VARCHAR-FALSE  VALUE LOW-VALUE.
       88 DST-IS-VARCHAR-TRUE   VALUE X'01' THROUGH X'FF'.
       77 DST-IS-INTEGER        PIC X.
       88 DST-IS-INTEGER-FALSE  VALUE LOW-VALUE.
       88 DST-IS-INTEGER-TRUE   VALUE X'01' THROUGH X'FF'.
       77 DST-IS-SMALLINT       PIC X.
       88 DST-IS-SMALLINT-FALSE VALUE LOW-VALUE.
       88 DST-IS-SMALLINT-TRUE  VALUE X'01' THROUGH X'FF'.
      *
       01 WORK-BYTES       PIC S9(4) COMP-5.
       01 WORK-AREA-OUT-CHAR      PIC X(200).
       01 WORK-AREA-OUT-VARCHAR.
               05 WA-VCR-LEN      PIC S9(4) COMP-5.
               05 WA-VCR-DATA     PIC X(200).
       01 WRK-TALLY1       PIC S9(4) COMP-5.
       01 WRK-TALLY2       PIC S9(4) COMP-5.
       01 WRK-TALLYX       PIC S9(4) COMP-5.
      *
       01 WRK-PARM-G.
          05 WRK-PARM-AREA    PIC X(30).
          05 WRK-PARM-NUMG REDEFINES WRK-PARM-AREA.
             10 WRK-PARM-NUM  PIC S9(9) COMP-5 OCCURS 7 TIMES.
             10 WRK-PARM-NUM8 PIC S9(4) COMP-5.
          05 WRK-EXTRA-AREA   PIC X(70).
      *
       LINKAGE SECTION.

       01 INIT-DEST PIC X(200).

      *----------------------------------------------------------------
      *  THIS IS THE LIST OF PARAMETERS THAT ARE PASSED TO THE EXIT
      *  FOR IDENTIFICATION PURPOSES.  IT ALSO INCLUDES THE SUBSCRIPT
      *  OF THE DESTINATION COLUMN THAT WE ARE TO SUPPLY A VALUE TO
      *----------------------------------------------------------------
       01  PARMAREA.
           05  PARMSSN                 PIC X(4).
           05  PARMOPTID               PIC X(4).
           05  PARMUSERID              PIC X(8).
           05  PARMSQLID               PIC X(128).
           05  PARMSCRIDV              PIC X(128).
           05  PARMSTBNML              PIC S9(4) COMP-5.
           05  PARMSTBNMV              PIC X(128).
           05  PARMDCRIDV              PIC X(128).
           05  PARMDTBNML              PIC S9(4) COMP-5.
           05  PARMDTBNMV              PIC X(128).
           05  PARMDESTSUB             PIC S9(4) COMP-5.
           05  PARMFLAG                PIC 9.
           05  FILLER                  PIC X.
           05  PARM-GLOBAL-WORK        POINTER.
           05  PARM-TABLE-WORK         POINTER.
           05  PARM-USER-PARMS         POINTER.
           05  PARM-CURRENT-ROWNUM     PIC S9(9) COMP-5.
           05  PARM-TOTAL-TABLEROWS    PIC S9(9) COMP-5.
      *----------------------------------------------------------------
      *  THIS IS THE SQLDA FOR THE SOURCE ROW.  IT DESCRIBES THE TYPE,
      *  LENGTH AND ADDRESS OF EACH COLUMN IN THE SOURCE ROW.
      *----------------------------------------------------------------
       01  SSQLDA.
           05  SSQLDAID                PIC X(8).
           05  SSQLDABC                PIC S9(9) COMP-5 SYNC.
           05  SSQLN                   PIC S9(4) COMP-5 SYNC.
           05  SSQLD                   PIC S9(4) COMP-5 SYNC.
           05  SSQLVAR                 OCCURS 1 TO 300 TIMES
                                       DEPENDING ON SSQLN
                                       INDEXED BY SSQLVAR-IX.
               10  SSQLTYPE            PIC S9(4) COMP-5 SYNC.
               10  SSQLLEN             PIC S9(4) COMP-5 SYNC.
               10  SSQLDECINFO         REDEFINES SSQLLEN.
                   15 SSQLPRECISION    PIC X.
                   15 SSQLSCALE        PIC X.
               10  SSQLDATA            POINTER.
               10  SSQLIND             POINTER.
               10  SSQLNAME.
                   15  SSQLNAMEL       PIC S9(4) COMP-5 SYNC.
                   15  SSQLNAMEC       PIC X(30).
      *----------------------------------------------------------------
      *  THIS IS THE SQLDA FOR THE DESTINATION ROW.  IT IS IDENTICAL TO
      *  THE SOURCE SQLDA BUT SHOWS THE DATA FOR THE DESTINATION TABLE.
      *----------------------------------------------------------------
       01  DSQLDA.
           05  DSQLDAID                PIC X(8).
           05  DSQLDABC                PIC S9(9) COMP-5 SYNC.
           05  DSQLN                   PIC S9(4) COMP-5 SYNC.
           05  DSQLD                   PIC S9(4) COMP-5 SYNC.
           05  DSQLVAR                 OCCURS 1 TO 300 TIMES
                                       DEPENDING ON DSQLN
                                       INDEXED BY DSQLVAR-IX.
               10  DSQLTYPE            PIC S9(4) COMP-5 SYNC.
               10  DSQLLEN             PIC S9(4) COMP-5 SYNC.
               10  DSQLDECINFO         REDEFINES DSQLLEN.
                   15 DSQLPRECISION    PIC X.
                   15 DSQLSCALE        PIC X.
               10  DSQLDATA            POINTER.
               10  DSQLIND             POINTER.
               10  DSQLNAME.
                   15  DSQLNAMEL       PIC S9(4) COMP-5 SYNC.
                   15  DSQLNAMEC       PIC X(30).

       01 COLEXIT-AREA.
          05 WA-RETURN-MSG PIC X(252).
          05 WA-EXIT-WORK-PTR POINTER.
          05 WA-LOGGING       PIC X.
             88 LOGGING        VALUE 'Y'.
             88 NOT-LOGGING    VALUE 'N'.
          05 WA-DEST-COL-TYPE PIC X.
             88 WA-TYPE-INTEGER VALUE 'I'.
             88 WA-TYPE-DECIMAL VALUE 'D'.
             88 WA-TYPE-CHAR    VALUE 'C'.
             88 WA-TYPE-VARCHAR VALUE 'V'.
          05 WA-NULLABLE      PIC X.
             88 IS-NULLABLE    VALUE 'Y'.
             88 NOT-NULLABLE   VALUE 'N'.
          05 FILLER           PIC X.
          05 WA-PRECISION     PIC 99 USAGE COMP.
          05 WA-BYTES-TO-MOVE PIC 99 USAGE COMP.
          05 WA-PROV-TOKEN-SSN COMP-2.
          05 WA-IX-SAVE             PIC S9(9) COMP-5 SYNC.
          05 WA-DESTSUB             PIC S9(4) COMP-5.
          05 WA-FP-PROV-INIT USAGE FUNCTION-POINTER.
          05 WA-FP-PROV-SRVC USAGE FUNCTION-POINTER.
          05 WA-FP-PROV-TERM USAGE FUNCTION-POINTER.

       01 PARM-AREA PIC X(200).

       PROCEDURE DIVISION USING PARMAREA SSQLDA DSQLDA COLEXIT-AREA.
           MOVE 0 TO RETURN-CODE

      *
      * Rows are available for processing when the destination
      * subscript is greater than zero.  Otherwise this is a
      * termination call and clean up is done.
      *
           IF PARMDESTSUB > 0 THEN

      *
      * If this is the first row then initialize ODPP services
      *
             IF PARM-CURRENT-ROWNUM = 1 THEN
               MOVE LOW-VALUES TO EXIT-WORK

      *
      * Match the destination column to the source column
      *
               MOVE PARMDESTSUB TO EW-DST-VAR-SUB
               SET DSQLVAR-IX TO PARMDESTSUB
               SET SSQLVAR-IX TO 1
      *
      * If user parm is supplied use that value for Source column name
      * otherwise search for the Destination column name
      * in source list.
      *
               IF PARM-USER-PARMS IS NOT EQUAL TO NULL
                 SET ADDRESS OF PARM-AREA TO PARM-USER-PARMS
                 MOVE ZERO TO WRK-TALLY1
                 INSPECT PARM-AREA TALLYING WRK-TALLY1
                         FOR CHARACTERS BEFORE INITIAL X'00'
                 SUBTRACT 2 FROM WRK-TALLY1
                 MOVE FUNCTION UPPER-CASE (PARM-AREA(2:WRK-TALLY1))
                      TO WRK-PARM-AREA
                 INSPECT WRK-PARM-AREA REPLACING ALL ' ' BY X'00'
               ELSE
                 MOVE DSQLNAMEC(PARMDESTSUB) TO WRK-PARM-AREA
               END-IF
               MOVE ZERO TO WRK-TALLY1
      *        INSPECT WRK-PARM-AREA TALLYING WRK-TALLY1
      *                FOR CHARACTERS BEFORE INITIAL X'00'
      *        DISPLAY "The Source column name is " WRK-PARM-AREA
      *        DISPLAY "Length of src col is " WRK-TALLY1
      *        MOVE ZERO TO WRK-TALLY1
      *        INSPECT DSQLNAMEC(PARMDESTSUB) TALLYING WRK-TALLY1
      *           FOR CHARACTERS BEFORE INITIAL X'00'
      *        DISPLAY "Dest column name is " DSQLNAMEC(PARMDESTSUB)
      *        DISPLAY "Length of dest col is " WRK-TALLY1

               SEARCH SSQLVAR
                 AT END
                   MOVE 8 TO RETURN-CODE
                   DISPLAY "Cannot match specified source column or "
                   DISPLAY "cannot match destination to source column"
                 WHEN SSQLNAMEC(SSQLVAR-IX) =
                      WRK-PARM-AREA
                      SET EW-SRC-VAR-SUB TO SSQLVAR-IX
               END-SEARCH
               IF RETURN-CODE NOT = 0 THEN
                 GOBACK
               END-IF

      *
      * Initialize the ODPP framework
      *
               SET CM-ARG-PTR TO NULL
               CALL 'Provider_FrmwInit'
                 USING
                   BY VALUE CM-ARG-PTR
                 RETURNING RETURN-CODE
               IF RETURN-CODE = ODPP-OS-LIB-MUTEX-ALREADY-INIT THEN
                 MOVE 0 TO RETURN-CODE
               ELSE
                 IF RETURN-CODE NOT = 0 THEN
                   DISPLAY
                     "Framework initialization failed rc=" RETURN-CODE
                   GOBACK
                 END-IF
               END-IF

      *
      * Initialize the Service Provider
      *
      *                           Service Definition body
               MOVE LOW-VALUES TO DP-SVC-DEF-BODY
      *                           Field Definition body
               MOVE LOW-VALUES TO DP-FIELD-DEF-BODY(1)
               MOVE LOW-VALUES TO DP-FIELD-DEF-BODY(2)
      *                           Initialization parms for
      *                           current service.
               MOVE LOW-VALUES TO DP-INIT-OP-DEF-BODY(1),
                             DP-INIT-OP-DEF-BODY(2),
                             DP-INIT-OP-DEF-BODY(3),
                             DP-INIT-OP-DEF-BODY(4),
                             DP-INIT-OP-DEF-BODY(5)

               MOVE LENGTH OF DP-SVC-DEF TO STRUCT-LEN OF DP-SVC-DEF
               COMPUTE STRUCT-LEN OF DP-FIELD-DEF-ARRAY(1)
                 = LENGTH OF DP-FIELD-DEF-HEADER
                   + LENGTH OF DP-FIELD-DEF-BODY
               COMPUTE STRUCT-LEN OF DP-FIELD-DEF-ARRAY(2)
                 = LENGTH OF DP-FIELD-DEF-HEADER
                   + LENGTH OF DP-FIELD-DEF-BODY
               COMPUTE STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(1),
                       STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(2),
                       STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(3),
                       STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(4),
                       STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(5)
                 = LENGTH OF DP-INIT-OP-DEF-HEADER
                   + LENGTH OF DP-INIT-OP-DEF-BODY

      *       * Show where the first Initialization parameter
      *       *  block is located.
               SET PARAMS-PTR TO ADDRESS OF DP-INIT-OP-DEF-ARRAY(1)
      *       * Show where the first field definition block is
      *       * located.
               SET FLD-DEF-PTR TO ADDRESS OF DP-FIELD-DEF-ARRAY(1)
               SET NEXT-PTR OF DP-FIELD-DEF-HEADER(1)
                  TO ADDRESS OF DP-FIELD-DEF-HEADER(2)
      *        A separate field-def source ptr will hold dest value.
               MOVE X"00" TO COPY-TO-DEST

      *        "M" represents specifying column name in
      *        character (SBCS/MBCS) format.
      *        This is normally used for z/OS environment.
               MOVE "M" TO SUB-TYPE(1)

               MOVE LOW-VALUES TO COLUMN-NAME-INFO-ARRAY(1)
               MOVE SPACES TO SOURCE-COLUMN-NAME
               MOVE SPACES TO DEST-COLUMN-NAME
               MOVE SPACES TO HASH-COLUMN-NAME
               MOVE
                 SSQLNAMEC(EW-SRC-VAR-SUB)(1:SSQLNAMEL(EW-SRC-VAR-SUB))
                 TO SOURCE-COLUMN-NAME
               MOVE
                 DSQLNAMEC(PARMDESTSUB)(1:DSQLNAMEL(PARMDESTSUB))
                 TO DEST-COL-D
               MOVE "H" TO DEST-COL-H
               MOVE DEST-COLUMN-NAME TO HASH-COLUMN-NAME
               MOVE 30 TO COL-NAME-BYTES(1)
               SET MC-PTR(1) TO ADDRESS OF COLUMN-NAME-INFO-ARRAY(1)
               SET COL-NAME-PTR(1) TO ADDRESS OF SOURCE-COLUMN-NAME
               MOVE -1 TO COL-NAME-CODE-PAGE(1)
               MOVE RDB-NONE TO COL-NAME-DBMS-TYPE(1)
      *        FIELD-DEF(2) REPRESENTS OUTPUT FIELD DEF THAT
      *        COULD BE DIFFERENT FROM INPUT FIELD DEF
               MOVE 30 TO COL-NAME-BYTES(2)
               MOVE "M" TO SUB-TYPE(2)
               SET MC-PTR(2) TO ADDRESS OF COLUMN-NAME-INFO-ARRAY(2)
               SET COL-NAME-PTR(2) TO ADDRESS OF DEST-COLUMN-NAME
               MOVE -1 TO COL-NAME-CODE-PAGE(2)
               MOVE RDB-NONE TO COL-NAME-DBMS-TYPE(2)

               MOVE RDB-NONE TO DATA-DBMS-TYPE(1)
               MOVE RDB-NONE TO DATA-DBMS-TYPE(2)
      *        Use -1 to default to system environment
      *        defined code page.
               MOVE -1 TO DATA-CODE-PAGE(1)
               MOVE -1 TO DATA-CODE-PAGE(2)
      *        Determine the datatype of Input
      *        DISPLAY "VAL OF SRC DATATYPE " SSQLTYPE(EW-SRC-VAR-SUB)
               IF SSQLTYPE(EW-SRC-VAR-SUB) = DB2-CHAR OR
                   SSQLTYPE(EW-SRC-VAR-SUB)= DB2-CHAR + 1 THEN
                 MOVE ODPPDATATYPE-CHAR TO DATA-TYPE(1)
      *          DISPLAY "PROCESSING SOURCE CHAR FIELD"
                 MOVE X'01' TO SRC-IS-CHAR
                 END-IF
               IF SSQLTYPE(EW-SRC-VAR-SUB) = DB2-VARCHAR OR
                   SSQLTYPE(EW-SRC-VAR-SUB) = DB2-VARCHAR + 1 THEN
                 MOVE ODPPDATATYPE-VARCHAR TO DATA-TYPE(1)
                 MOVE X'01' TO SRC-IS-VARCHAR
      *          DISPLAY "PROCESSING SOURCE VARCHAR FIELD"
                 END-IF
               IF SSQLTYPE(EW-SRC-VAR-SUB) = DB2-INT OR
                   SSQLTYPE(EW-SRC-VAR-SUB) = DB2-INT + 1 THEN
                 MOVE ODPPDATATYPE-INTEGER TO DATA-TYPE(1)
                 MOVE X'01' TO SRC-IS-VARCHAR
      *          DISPLAY "PROCESSING SOURCE VARCHAR FIELD"
                 END-IF
               IF SSQLTYPE(EW-SRC-VAR-SUB) = DB2-SMALLINT OR
                   SSQLTYPE(EW-SRC-VAR-SUB) = DB2-SMALLINT + 1 THEN
                 MOVE ODPPDATATYPE-SMALLINT TO DATA-TYPE(1)
                 MOVE X'01' TO SRC-IS-VARCHAR
      *          DISPLAY "PROCESSING SOURCE VARCHAR FIELD"
                 END-IF
      *
               MOVE SSQLLEN(EW-SRC-VAR-SUB) TO COL-LENGTH(1)
      *
      *        Determine the datatype of Output
      *        DISPLAY "VAL OF DEST DATATYPE " DSQLTYPE(EW-DST-VAR-SUB)
               IF DSQLTYPE(EW-DST-VAR-SUB) = DB2-CHAR OR
                   DSQLTYPE(EW-DST-VAR-SUB)= DB2-CHAR + 1 THEN
                 MOVE ODPPDATATYPE-CHAR TO DATA-TYPE(2)
      *          DISPLAY "PROCESSING SOURCE CHAR FIELD"
                 MOVE X'01' TO SRC-IS-CHAR
                 END-IF
               IF DSQLTYPE(EW-DST-VAR-SUB) = DB2-VARCHAR OR
                   DSQLTYPE(EW-DST-VAR-SUB) = DB2-VARCHAR + 1 THEN
                 MOVE ODPPDATATYPE-VARCHAR TO DATA-TYPE(2)
                 MOVE X'01' TO SRC-IS-VARCHAR
      *          DISPLAY "PROCESSING SOURCE VARCHAR FIELD"
                 END-IF
               IF DSQLTYPE(EW-DST-VAR-SUB) = DB2-INT OR
                   DSQLTYPE(EW-DST-VAR-SUB) = DB2-INT + 1 THEN
                 MOVE ODPPDATATYPE-INTEGER TO DATA-TYPE(2)
                 MOVE X'01' TO SRC-IS-VARCHAR
      *          DISPLAY "PROCESSING SOURCE VARCHAR FIELD"
                 END-IF
               IF DSQLTYPE(EW-DST-VAR-SUB) = DB2-SMALLINT OR
                   DSQLTYPE(EW-DST-VAR-SUB) = DB2-SMALLINT + 1 THEN
                 MOVE ODPPDATATYPE-SMALLINT TO DATA-TYPE(2)
                 MOVE X'01' TO SRC-IS-VARCHAR
      *          DISPLAY "PROCESSING SOURCE VARCHAR FIELD"
                 END-IF
      *
               MOVE DSQLLEN(EW-DST-VAR-SUB) TO COL-LENGTH(2)
      *        Number of DP-FIELD-DATA-DEF blocks.
      *        Hash needs to use two field defs.
               MOVE 2 TO FLD-COUNT
      *        Set the number of parameters
      *        (DP-INIT-OP-DEF-ARRAY blocks) for this
      *        Provider Service.
               MOVE 5 TO PARAM-COUNT

      *
      * Initialize the ODPP rowset, row and field  structures
      *
               MOVE LOW-VALUES TO DP-ROWSET-DEF-BODY
               SET NEXT-PTR OF DP-ROW-DEF TO NULL
               MOVE LENGTH OF DP-ROWSET-DEF
                 TO STRUCT-LEN OF DP-ROWSET-DEF
      *        Will always be 1 in an Optim/z Column Map Exit.
               MOVE 1 TO ROW-COUNT OF DP-ROWSET-DEF

               MOVE LOW-VALUES TO DP-ROW-DEF
               MOVE LENGTH OF DP-ROW-DEF
                 TO STRUCT-LEN OF DP-ROW-DEF

               MOVE LOW-VALUES TO DP-FIELD-DATA-DEF-BODY(1)
               MOVE LOW-VALUES TO DP-FIELD-DATA-DEF-BODY(2)
               SET NEXT-PTR OF DP-FIELD-DATA-DEF-ARRAY(1) TO
                    ADDRESS OF DP-FIELD-DATA-DEF-ARRAY(2)
               SET NEXT-PTR OF DP-FIELD-DATA-DEF-ARRAY(2) TO NULL
               COMPUTE STRUCT-LEN OF DP-FIELD-DATA-DEF-ARRAY(1),
                       STRUCT-LEN OF DP-FIELD-DATA-DEF-ARRAY(2)
                 = LENGTH OF DP-FIELD-DATA-DEF-ARRAY(1)

      *       *
      *       * Initialization parameters for HASH
      *       *
               SET NEXT-PTR OF DP-INIT-OP-DEF-ARRAY(1) TO
                 ADDRESS OF DP-INIT-OP-DEF-ARRAY(2)
               SET NEXT-PTR OF DP-INIT-OP-DEF-ARRAY(2) TO
                 ADDRESS OF DP-INIT-OP-DEF-ARRAY(3)
               SET NEXT-PTR OF DP-INIT-OP-DEF-ARRAY(3) TO
                 ADDRESS OF DP-INIT-OP-DEF-ARRAY(4)
               SET NEXT-PTR OF DP-INIT-OP-DEF-ARRAY(4) TO
                 ADDRESS OF DP-INIT-OP-DEF-ARRAY(5)
      *        Switch is not needed but it is a mandatory operand
      *        so set it to ODPP-OPR-SWITCH-NA
               MOVE ODPP-OPR-SWITCH-NA TO PARAMETER-ID(1)
               MOVE PARAM-VAL-NONE TO VALUE-SUB-TYPE(1)
      *        Set the column index of the source column
               MOVE ODPP-OPR-SOURCE-COLINDEX TO PARAMETER-ID(2)
               MOVE PARAM-VAL-NUM TO VALUE-SUB-TYPE(2)
               MOVE 0 TO PARAM-VAL-INT(2)
      *        Set the HASH column output name
               MOVE ODPP-OPR-HASH-DEST-COL TO PARAMETER-ID(3)
               MOVE PARAM-VAL-MC TO VALUE-SUB-TYPE(3)
               SET HASHCOL-VAL-PTR TO ADDRESS OF HASH-COLUMN-NAME
               SET PARAM-VAL-PTR(3) TO ADDRESS OF HASHCOL
               MOVE RDB-NONE TO HASHCOL-DBMS-TYPE
               MOVE -1 TO HASHCOL-CODE-PAGE
               MOVE LENGTH OF HASH-COLUMN-NAME TO VALUE-BUF-BYTES(3)
               MOVE ZERO TO WRK-TALLY1 WRK-TALLY2
               INSPECT HASH-COLUMN-NAME TALLYING WRK-TALLY1
                  FOR CHARACTERS BEFORE INITIAL X'00'
               INSPECT HASH-COLUMN-NAME TALLYING WRK-TALLY2
                  FOR ALL SPACES
               COMPUTE WRK-TALLYX = WRK-TALLY1 - WRK-TALLY2 + 1
               MOVE X'00' TO HASH-COLUMN-NAME(WRK-TALLYX:1)
               MOVE X'00' TO DEST-COLUMN-NAME(WRK-TALLYX:1)
      *        Choose method type - only choice for HASH
               MOVE ODPP-OPR-METHOD TO PARAMETER-ID(4)
               MOVE PARAM-VAL-NUM TO VALUE-SUB-TYPE(4)
               MOVE ODPP-METHOD-HASH TO PARAM-VAL-INT(4)
      *        Set the maximum returned value from Hash
               MOVE ODPP-OPR-HASH-MAXVALUE TO PARAMETER-ID(5)
               MOVE PARAM-VAL-NUM TO VALUE-SUB-TYPE(5)
               MOVE 20099 TO PARAM-VAL-INT(5)

      *        DISPLAY "Calling Provider_Init .... "
               CALL 'Provider_Init'
                 USING
                   BY VALUE ADDRESS OF EW-SVC-TOKEN,
                   BY VALUE ADDRESS OF PRV-NAME,
                   BY VALUE 3,
                   BY VALUE ADDRESS OF DP-SVC-DEF,
                   BY VALUE ALLOC-INIT-BLOCK
                 RETURNING RETURN-CODE
               IF RETURN-CODE NOT = 0 THEN
                 DISPLAY
                   "Provider initialization failed rc=" RETURN-CODE
                 GOBACK
               END-IF
             END-IF

      * Continue processing - for every row ...
      *
      * Populate the rowset structure
      *
      *      DISPLAY " "
      *      DISPLAY "Processing a row .... "
             SET ROW-DEFINE-PTR TO ADDRESS OF DP-ROW-DEF
             MOVE 0 TO LAST-PRCS-ROW
             MOVE X"00" TO PROCESSED
             MOVE X"00" TO HAS-ERROR
             MOVE X"00" TO SRC-NULL(1)

      *
      * Set up the data definition structure
      *
             MOVE SSQLLEN(EW-SRC-VAR-SUB) TO SRC-BUF-LEN(1)
             SET SRC-BUF-PTR(1) TO SSQLDATA(EW-SRC-VAR-SUB)
             MOVE DSQLLEN(PARMDESTSUB) TO SRC-BUF-LEN(2)
             SET SRC-BUF-PTR(2) TO DSQLDATA(PARMDESTSUB)

      *
      * Set up the row definition structure
      *
             SET FLD-DATA-DEFINE-PTR TO
                 ADDRESS OF DP-FIELD-DATA-DEF-ARRAY(1)
             MOVE 2 TO S-COUNT OF DP-ROW-DEF

      *
      * Call the provider service
      *
             CALL 'Provider_Service'
               USING
                 BY VALUE EW-SVC-TOKEN,
                 BY VALUE ODPP-METHOD-DEFAULT,
                 BY VALUE NULL-PTR,
                 BY VALUE ADDRESS OF DP-ROWSET-DEF
               RETURNING RETURN-CODE
             IF RETURN-CODE NOT = 0 THEN
               DISPLAY "HASH service failed rc=" RETURN-CODE
               GOBACK
             END-IF
      *      Clear remaining bytes of area if CHAR field
             IF SRC-IS-CHAR-TRUE THEN
               IF DSQLLEN(EW-DST-VAR-SUB) > SRC-BUF-LEN(2)
                 COMPUTE WORK-BYTES = DSQLLEN(EW-DST-VAR-SUB) -
                         SRC-BUF-LEN(2)
                 SET ADDRESS OF INIT-DEST TO SRC-BUF-PTR(2)
                 MOVE SPACE TO INIT-DEST(SRC-BUF-LEN(2) + 1: WORK-BYTES)
               END-IF
             END-IF

             MOVE 0 TO RETURN-CODE
           ELSE
      *
      *      This is the Termination call from Column Map services.
      *      Clean up the Provider Service environment.
      *
             CALL 'Provider_Term'
               USING
                 BY VALUE EW-SVC-TOKEN
               RETURNING RETURN-CODE

           END-IF.
           GOBACK.
